"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _debounce = _interopRequireDefault(require("lodash/fp/debounce"));

var _find = _interopRequireDefault(require("lodash/fp/find"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-common/lib/format-message"));

var _Select = _interopRequireDefault(require("@instructure/ui-forms/lib/components/Select"));

var _AccessibleContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/AccessibleContent"));

var AsyncSearch =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(AsyncSearch, _Component);

  function AsyncSearch() {
    var _this;

    (0, _classCallCheck2.default)(this, AsyncSearch);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AsyncSearch).apply(this, arguments));
    _this.state = {
      loading: false,
      emptyOption: "\u0627\u0643\u062A\u0628 \u0644\u0644\u0628\u062D\u062B",
      searchResult: [],
      searchInput: ''
    };

    _this.cleanResults = function () {
      return _this.setState({
        emptyOption: "\u0627\u0643\u062A\u0628 \u0644\u0644\u0628\u062D\u062B",
        searchResult: []
      });
    };

    _this.handleClose = function () {
      if (!_this.state.searchInput) {
        _this.cleanResults();
      }
    };

    _this.handleSearchInputChange = function (event, value) {
      _this.setState({
        searchInput: value,
        loading: !!value
      });

      if (!value) {
        _this.cleanResults();
      } else {
        _this.search(value);
      }
    };

    _this.handleSearchSelectionChange = function (event, newValues) {
      _this.props.onSelectionChange(newValues.map(function (_ref) {
        var id = _ref.id;
        return (0, _find.default)({
          uuid: id
        }, _this.state.searchResult) || (0, _find.default)({
          uuid: id
        }, _this.props.selectedOption);
      }));
    };

    _this.formatSelectedOption = function (option) {
      return _react.default.createElement(_AccessibleContent.default, {
        alt: "\u0625\u0632\u0627\u0644\u0629 " + option.label
      }, option.label);
    };

    _this.search = (0, _debounce.default)(_this.props.debounceDelay, function (value) {
      // TODO add the promise cancellation for avoiding having disordered requests
      _this.props.search(value).then(function (searchResult) {
        _this.setState({
          searchResult: searchResult,
          emptyOption: "\u0644\u0627 \u062A\u0648\u062C\u062F \u0646\u062A\u0627\u0626\u062C",
          loading: false
        });
      });
    });
    return _this;
  }

  (0, _createClass2.default)(AsyncSearch, [{
    key: "render",
    value: function render() {
      var selectedOption = this.props.selectedOption.map(function (_ref2) {
        var uuid = _ref2.uuid,
            fullName = _ref2.fullName;
        return {
          id: uuid,
          value: uuid,
          label: fullName
        };
      });
      return _react.default.createElement(_Select.default, {
        editable: true,
        "data-automation": "sdk-item-bank-share-input",
        onInputChange: this.handleSearchInputChange,
        value: this.state.searchInput,
        emptyOption: this.state.emptyOption,
        loadingText: this.state.loading ? "\u062C\u0627\u0631\u064D \u062A\u062D\u0645\u064A\u0644 \u0627\u0644\u062E\u064A\u0627\u0631\u0627\u062A" : null,
        onClose: this.handleClose,
        selectedOption: selectedOption,
        onChange: this.handleSearchSelectionChange,
        filter: this.props.selectionFilter,
        formatSelectedOption: this.formatSelectedOption,
        placeholder: "\u0623\u062F\u062E\u0644 \u0627\u0644\u0627\u0633\u0645 \u0623\u0648 \u0645\u0639\u0631\u0641 \u062A\u0633\u062C\u064A\u0644 \u0627\u0644\u062F\u062E\u0648\u0644...",
        label: "\u0627\u0644\u0645\u0634\u0627\u0631\u0643\u0629 \u0645\u0639",
        multiple: true
      }, this.state.searchResult.map(function (person) {
        return _react.default.createElement("option", {
          "data-automation": "sdk-item-bank-acoption-user-".concat(person.uuid),
          value: person.uuid,
          key: person.uuid
        }, person.fullName);
      }));
    }
  }]);
  AsyncSearch.displayName = "AsyncSearch";
  return AsyncSearch;
}(_react.Component);

exports.default = AsyncSearch;
AsyncSearch.propTypes = {
  search: _propTypes.default.func.isRequired,
  onSelectionChange: _propTypes.default.func.isRequired,
  selectedOption: _propTypes.default.arrayOf(_propTypes.default.shape({
    avatar: _propTypes.default.string,
    fullName: _propTypes.default.string.isRequired,
    uuid: _propTypes.default.string.isRequired
  })).isRequired,
  selectionFilter: _propTypes.default.func,
  debounceDelay: _propTypes.default.number
};
AsyncSearch.defaultProps = {
  selectionFilter: function selectionFilter(value) {
    return value;
  },
  debounceDelay: 500
};