"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _immutable = require("immutable");

var _index = require("../index");

var _constants = require("@instructure/quiz-common/lib/constants");

var calls = function calls() {
  var _fromJS;

  var call1 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'success';
  var call2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'success';
  var call3 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'success';
  return (0, _immutable.fromJS)((_fromJS = {}, (0, _defineProperty2.default)(_fromJS, _constants.CREATE_QTI_IMPORT, {
    requestStatus: call1
  }), (0, _defineProperty2.default)(_fromJS, _constants.FILE_UPLOAD_URL_CALL, {
    requestStatus: call2
  }), (0, _defineProperty2.default)(_fromJS, _constants.FILE_UPLOAD_CALL, {
    requestStatus: call3
  }), _fromJS));
};

var callsToCheck = [_constants.CREATE_QTI_IMPORT, _constants.FILE_UPLOAD_CALL, _constants.FILE_UPLOAD_URL_CALL];
describe('.callProgress', function () {
  it('returns 1 if all calls are made', function () {
    var callRatio = (0, _index.callProgress)(callsToCheck, calls());
    expect(callRatio).to.eq(1);
  });
  it('returns 0 if all calls are not made', function () {
    var callRatio = (0, _index.callProgress)(callsToCheck, calls(false, false, false));
    expect(callRatio).to.eq(0, 0.1);
  });
  it('returns 0 if all calls are not made', function () {
    var callRatio = (0, _index.callProgress)(callsToCheck, calls(false, false, false));
    expect(callRatio).to.eq(0, 0.1);
  });
  it('returns a non-zero number if calls are not made', function () {
    var callRatio = (0, _index.callProgress)(callsToCheck, calls(false));
    expect(callRatio).to.be.closeTo(0.6, 0.1);
  });
});
describe('.progressValue', function () {
  it('returns the value of callProgress * 50 when progressNumber is 0', function () {
    var pvNum = (0, _index.progressValue)(0, calls(false), callsToCheck);
    expect(pvNum).to.be.closeTo(0.6 * 50, 5);
  });
  it('returns the value of 1 + qtiImport.progressNumber * 50 when progressNumber is not 0', function () {
    var pvNum = (0, _index.progressValue)(0.3, calls(), callsToCheck);
    expect(pvNum).to.be.closeTo(1.3 * 50, 0.9);
  });
});