"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _ = _interopRequireDefault(require("../"));

var styles = {
  componentId: 'cqBsX',
  template: function template(theme) {
    return "\n\n.CardContent__styles__content {\n  border-radius: ".concat(theme.contentBorderRadius || 'inherit', ";\n  background-color: ").concat(theme.contentBackgroundColor || 'inherit', ";\n  box-shadow: ").concat(theme.contentBoxShadow || 'inherit', ";\n  transition: ").concat(theme.contentTransitionDuration || 'inherit', " ease;\n  max-width: ").concat(theme.contentMaxWidth || 'inherit', ";\n  margin: ").concat(theme.contentMargin || 'inherit', " auto;\n}\n\n@media screen and (--phoneBreakPoint) {\n  .CardContent__styles__content {\n    margin: ").concat(theme.phoneContentMargin || 'inherit', " auto;\n  }\n}\n");
  },
  'content': 'CardContent__styles__content'
};
describe('CardContent', function () {
  it('renders children in the card', function () {
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_.default, null, "Cool Content"));
    expect(wrapper.text()).to.include('Cool Content');
  });
  it('styles the card', function () {
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_.default, null, "Cool Content"));
    expect(wrapper.prop('className')).to.equal(styles.content);
  });
  it('appends className to card', function () {
    var wrapper = (0, _enzyme.shallow)(_react.default.createElement(_.default, {
      className: "myClass"
    }, "Cool Content"));
    expect(wrapper.prop('className')).to.include('myClass');
  });
});