"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _presenter = _interopRequireDefault(require("../presenter"));

describe('RichContentInput', function () {
  var props = {
    textareaId: 'uniqTextareaId',
    onContinue: sinon.stub(),
    openModal: sinon.stub()
  };
  var testbed = createTestbed(withContext(_presenter.default), props);
  it('should render', function () {
    testbed.render();
    var rceComponent = testbed.findChildByType(_presenter.default);
    expect(rceComponent).to.not.be.undefined();
  });
  describe('a11y tests', function () {
    it('should meet a11y standards', function (done) {
      testbed.render(); // ignoring button-name because of the textcolor tinymce plugin

      testbed.checkA11yStandards(done, {
        ignores: ['aria-allowed-role', // TODO: remove this when canvas-rce is fixed
        'button-name']
      });
    });
  });
});