"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("../index"));

describe('ReportList', function () {
  var testbed = createTestbed(_index.default, {
    children: [_react.default.createElement("div", {
      key: "0"
    }, "Moocow"), _react.default.createElement("span", {
      key: "1"
    }, "Gorilla"), _react.default.createElement("div", {
      key: "2"
    }, "Bunny")]
  });
  shouldRenderComponent(testbed, {}, _index.default);
  it('should render title', function () {
    testbed.render();
    expect(testbed.getText()).to.include('Reports');
  });
  it('should render children', function () {
    testbed.render();
    expect(testbed.getText()).to.include('Moocow');
    expect(testbed.getText()).to.include('Gorilla');
    expect(testbed.getText()).to.include('Bunny');
  });
  describe('a11y tests', function () {
    it('should meet a11y standards', function (done) {
      testbed.renderShallowly();
      testbed.checkA11yStandards(done);
    });
  });
});