"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _constants = require("@instructure/quiz-common/lib/constants");

var _Stimulus = _interopRequireDefault(require("../Stimulus"));

describe('Stimulus Record', function () {
  describe('#constructor', function () {
    it('defaults stimulusType to "text"', function () {
      var stimulus = new _Stimulus.default();
      expect(stimulus.get('stimulusType')).to.eq('text');
    });
  });
  describe('#isTemporary', function () {
    it('is true for a temporary record', function () {
      var stimulus = new _Stimulus.default({
        id: _constants.TEMPORARY_STIMULUS_ID
      });
      expect(stimulus.isTemporary()).to.be.true();
    });
    it('is false for a temporary record', function () {
      var stimulus = new _Stimulus.default({
        id: '33'
      });
      expect(stimulus.isTemporary()).to.be.false();
    });
  });
});