"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _Quiz = _interopRequireDefault(require("../../../../../records/Quiz"));

var _QuizInfo = _interopRequireDefault(require("../QuizInfo"));

var _Title = _interopRequireDefault(require("../../title/Title"));

var _Instructions = _interopRequireDefault(require("../../instructions/Instructions"));

describe('QuizInfo Component', function () {
  var QuizInfoWithContext = withContext(_QuizInfo.default);
  var testbed = createTestbed(QuizInfoWithContext, {
    quiz: new _Quiz.default({
      title: 'History of Rome: Quiz 1',
      instructions: 'Do your best!'
    }),
    actions: {}
  });
  shouldRenderComponent(testbed, {}, QuizInfoWithContext);
  it('should render a QuizTitle', function () {
    testbed.render();
    var builder = testbed.findChildByType(_Title.default);
    expect(builder).to.not.be.undefined();
  });
  it('should render a QuizInstructions', function () {
    testbed.render();
    var builder = testbed.findChildByType(_Instructions.default);
    expect(builder).to.not.be.undefined();
  });
  describe('a11y tests', function () {
    it('should meet a11y standards', function (done) {
      testbed.render();
      testbed.checkA11yStandards(done);
    });
  });
});