"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var actions = _interopRequireWildcard(require("../reporting"));

var _constants = require("@instructure/quiz-common/lib/constants");

describe('reporting actions creators', function () {
  describe('#addQuizAnalysis', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.addQuizAnalysis({})).to.deep.equal({
        type: _constants.ADD_QUIZ_ANALYSIS,
        payload: {}
      });
    });
  });
  describe('#addItemAnalyses', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.addItemAnalyses([])).to.deep.equal({
        type: _constants.ADD_ITEM_ANALYSES,
        payload: []
      });
    });
  });
  describe('#markQuizAnalysisNotFound', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.markQuizAnalysisNotFound('1')).to.deep.equal({
        type: _constants.QUIZ_ANALYSIS_NOT_FOUND,
        payload: '1'
      });
    });
  });
  describe('#markItemAnalysisNotFound', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.markItemAnalysisNotFound('1')).to.deep.equal({
        type: _constants.ITEM_ANALYSIS_NOT_FOUND,
        payload: '1'
      });
    });
  });
  describe('#toggleItemAnalysisRowExpanded', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.toggleItemAnalysisRowExpanded('1')).to.deep.equal({
        type: _constants.TOGGLE_ITEM_ANALYSIS_EXPANDED,
        payload: '1'
      });
    });
  });
});