"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _Link = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Link"));

var _index = _interopRequireDefault(require("../index"));

describe('ReportCard', function () {
  var testbed = createTestbed(_index.default, {
    name: 'Cool report',
    details: _react.default.createElement("span", null, "Something interesting here"),
    href: '/foo'
  });
  shouldRenderComponent(testbed, {}, _index.default);
  it('should render name', function () {
    testbed.render();
    expect(testbed.getText()).to.include('Cool report');
  });
  it('should render details', function () {
    testbed.render();
    expect(testbed.getText()).to.include('Something interesting here');
  });
  it('should link to href', function () {
    testbed.render();
    var link = testbed.findChildByType(_Link.default);
    expect(link).to.exist();
    expect(link.props.href).to.eq('/foo');
  });
  describe('a11y tests', function () {
    it('should meet a11y standards', function (done) {
      testbed.renderShallowly();
      testbed.checkA11yStandards(done);
    });
  });
});