"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _index = _interopRequireDefault(require("../index"));

var overlayStyles = {
  componentId: 'fDDFj',
  template: function template(theme) {
    return "\n\n.overlay__styles__root {\n  position: relative;\n  align-self: center;\n}\n\n.overlay__styles__overlay {\n  position: absolute;\n  top: 0;\n  left: 0;\n  cursor: pointer;\n  z-index: ".concat(theme.overlayZIndex || 'inherit', ";\n\n  height: 100%;\n  width: 100%;\n}\n\n.overlay__styles__overlay:hover {\n    box-sizing: border-box;\n    border-left: ").concat(theme.overlayBarSize || 'inherit', " solid ").concat(theme.overlayBarColor || 'inherit', ";\n  }\n");
  },
  'root': 'overlay__styles__root',
  'overlay': 'overlay__styles__overlay'
};
describe('Quiz Title Show', function () {
  var QuizTitleShowWithContext = withContext(_index.default);
  var testbed = createTestbed(QuizTitleShowWithContext, {});
  shouldRenderComponent(testbed, {}, QuizTitleShowWithContext);
  it('should render the overlay component', function () {
    testbed.render({});
    var overlayComponent = testbed.findChildrenByClass(overlayStyles.overlay)[0];
    expect(overlayComponent).to.not.be.undefined();
  });
  describe('a11y tests', function () {
    it('should meet a11y standards', function (done) {
      testbed.render();
      testbed.checkA11yStandards(done);
    });
  });
});