"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _immutable = require("immutable");

var _Item = _interopRequireDefault(require("../../../../../records/Item"));

var _index = _interopRequireDefault(require("../index"));

describe('EntrySave', function () {
  var ConnectedItemEdit = withContext(_index.default);
  var item = new _Item.default({
    id: '666',
    title: 'Tough Color Question',
    itemBody: 'Which color is happiest?',
    scoringData: {
      value: 'id'
    }
  });
  sinon.stub(item, 'getWorkingInstance').returns(item);
  var testbed = createTestbed(ConnectedItemEdit, {
    entry: item,
    errorsShowing: (0, _immutable.Map)(),
    isValid: true,
    isEditing: true,
    editable: true,
    clearChanges: sinon.stub()
  });
  useFakeFetching({
    dispatchStub: sinon.stub(),
    getStateStub: sinon.stub(),
    fetchStub: sinon.stub()
  });
  shouldRenderComponent(testbed, {}, _index.default);
});