"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var actions = _interopRequireWildcard(require("../sharedBanks"));

var _constants = require("@instructure/quiz-common/lib/constants");

describe('banks actions creators', function () {
  describe('#addShareBank', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.addSharedBanks({
        id: 1,
        uuid: 1,
        bankId: 2,
        permission: _constants.CAN_EDIT
      })).to.deep.equal({
        type: _constants.ADD_SHARED_BANKS,
        payload: {
          id: 1,
          uuid: 1,
          bankId: 2,
          permission: _constants.CAN_EDIT
        }
      });
    });
  });
  describe('#removeShareBank', function () {
    it('returns a well-formed and correct action', function () {
      expect(actions.removeSharedBank({
        id: 1,
        uuid: 1,
        bankId: 2,
        permission: _constants.CAN_EDIT
      })).to.deep.equal({
        type: _constants.REMOVE_SHARED_BANK,
        payload: {
          id: 1,
          uuid: 1,
          bankId: 2,
          permission: _constants.CAN_EDIT
        }
      });
    });
  });
});